#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>
#include "job.h"

job_t * new_empty_job ( ) {
    job_t * J = calloc ( 1, sizeof (job_t ) );
    assert( J );
    J->precedence = new_list ( );
    J->posteriority = new_list ( );
    J->rank = UNDEF;
    J->au_plus_tard = UNDEF;
    J->au_plus_tot = UNDEF;
    J->marge_totale = UNDEF;
    J->critique = false;
    return J;
}
job_t * new_job ( char * title ) {
    job_t * J = new_empty_job ( );
    J->title = strdup ( title );
    return J;
}
void free_job(job_t ** ptrJ ) {
    assert ( ptrJ && *ptrJ );
    if( (*ptrJ)->title ) free ( (*ptrJ)->title );
    free ( *ptrJ );
    *ptrJ = NULL;
}

void view_job ( job_t * J ) {
    printf ( "JOB %s\n\tpreceeded by [", get_job_tilte ( J ) );
    for(elmlist_t * E = get_head ( J->precedence ); E; E = get_suc ( E ) ) {
        printf ( " %s", get_job_tilte ( get_data ( E ) ) );
    }
    printf ( " ]\n" );
    // if ( !get_numelm ( J->posteriority ) ) printf ( "\t" );
    printf ( "\tfollowed by [" );
    for(elmlist_t * E = get_head(J->posteriority); E; E = get_suc(E)){
        printf(" %s", get_job_tilte(get_data(E)));
    }
    printf ( " ]\n" );
    printf ( "\tiDeg=%d\toDeg=%d\tlife=%2.2lf", J->input_degree, J->output_degree, J->life );
    printf ( "\trank=" );
    if ( J->rank == UNDEF ) printf ( "U" ); else printf ( "%d", J->rank );
    printf ( "\tearly=" );
    if(J->au_plus_tot == UNDEF ) printf("U"); else printf ( "%2.2lf",J->au_plus_tot );
    printf ( "\tlate=" );
    if(J->au_plus_tard == UNDEF ) printf("U"); else printf ( "%2.2lf",J->au_plus_tard );
    printf ( "\ttotale= " );
    if ( J->marge_totale == UNDEF ) printf("U"); else printf ( "%2.2lf", J->marge_totale );
    printf ( "\tcritical= " );
    if ( J->critique ) printf("Y\n"); else printf ( "N\n" );
}
