#include <stdlib.h>
#include <assert.h>
#include "list_elm.h"

list_elm_t * new_list_elm ( void * data ){
    list_elm_t * E = calloc(1,sizeof(list_elm_t));
    assert(E);
    E->data = data;
    return E;
}

void del_list_elm( list_elm_t * * E, void (*ptrf)() ){
    assert(E && *E);
    if (ptrf) {
        ptrf((*E)->data);
    }
    free(*E);
    *E = NULL;
}

list_elm_t * get_suc ( list_elm_t * E ){
    assert(E);
    return E->suc;
}
list_elm_t * get_pred ( list_elm_t * E );
void * get_data ( list_elm_t * E ){
    assert(E);
    return E->data;
}

void set_suc ( list_elm_t * E, list_elm_t * S ){
    assert(E);
    E->suc = S;
}

void set_pred ( list_elm_t * E, list_elm_t * P ){
    assert(E);
    E->pred = P;
}

void set_data ( list_elm_t * E, void * data ){
    assert(E);
    E->data = data;
}

void view_list_elm ( list_elm_t * E, void (*ptrf)() ){
    assert(E && ptrf);
    for(elmlist_t * E = E->head; E; E = get_suc(E)){
      void * d = E->data;
      (*ptrf)(d);
    }
}